#include <fstream>
#include <string>
using namespace std;

int dat[100005];
int tree[400005];

void build(int v, int l, int r)
{
	if (l == r)
	{
		tree[v] = dat[l];
	}
	else
	{
		int mid = (l + r) / 2;
		build(v*2, l, mid);
		build(v*2+1, mid+1, r);
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
}

int get(int v, int l, int r, int tl, int tr)
{
	if (tl == l && tr == r)
	{
		return tree[v];
	}
	else
	{
		int mid = (l + r) / 2;

		if (mid < tl)
		{
			return get(v*2+1, mid+1, r, tl, tr);
		}
		else if (mid >= tr)
		{
			return get(v*2, l, mid, tl, tr);
		}
		return get(v * 2, l, mid, tl, mid) + get(v * 2 + 1, mid + 1, r, mid+1, tr);
	}
}

void upd(int v, int l, int r, int pos, int val)
{
	if (l == r)
	{
		tree[v] = val;
	}
	else
	{
		int mid = (l + r) / 2;
		if (pos <= mid)
		{
			upd(v*2, l, mid, pos, val);
		}
		else
		{
			upd(v*2+1, mid+1, r, pos, val);
		}
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
}

int main()
{
	//string s = "10";
	ifstream in("input.txt");
	ofstream out("output.txt");

	
	int n, q, a, b, c, d, i, j;

	in >> n >> q;
	for (i = 1; i <= n; i++)
	{
		in >> dat[i];
	}
	build(1, 1, n);

	for (i = 0; i < q; i++)
	{
		in >> a >> b >> c;

		if (a == 1)
		{
			out << get(1, 1, n, b, c)<<"\n";
		}
		else
		{
			upd(1, 1, n, b, c);
		}
	}

	return 0;
}